﻿import flash.display.*;
import flash.geom.*;

class MultiPoint extends MovieClip {
	
	
	
	private var video:Video = null;
	
	// 1 ve 0 lardan olusan harite dizisi
	private var map:Array = null;
	private var w:Number = 0;
	private var h:Number = 0;
	
	//Arka plan rengi
	private var backColor:Number = 0x000000;
	//Resimde aranan renk
	private var targetColor:Number = 0xFFFFF7;
	
	//iki renk arasindaki fark
	private var F:Number = 15000;
	
	//5x5 lik bir kare alani varsa bu bir noktadir
	private var pointSize:Number = 2;
	//iki nokta arasinda olmasi gereken en az uzaklik
	private var minPointDistance = 10;
	
	//Ekranda bulunan noktalari iceren dizidir
	private var multiPoints:Array = null;
	
	
	
	
	public function MultiPoint() {
	}
	
	public function startProcessing(video:Video):Void {
		
		this.video = video;
		
		this.w = video.width;
		this.h = video.height;		
		map = new Array(w);
		for(var i = 0; i<w; i++) {
			map[i] = new Array(h);
		}
		
		this.multiPoints = new Array();
		
		
		this.onEnterFrame = this.onMyEnterFrame;
		//this.onMyEnterFrame();
		//this.calculatePoints();
	}
	
	public function stopProcessing():Void {
		this.video = null;
		this.onEnterFrame = null;
	}
	
	
	public function onMyEnterFrame():Void {		

		var bitmap:BitmapData = new BitmapData(w , h);
		bitmap.draw(video);
		
		var drawBitmap:BitmapData = new BitmapData(w , h, false, 0x000000);
		
		
		for(var y=0; y<h; y++) {
			for(var x=0; x<w; x++) {
				var color:Number = bitmap.getPixel(x, y);
				if(getNearColor(color)) {
					drawBitmap.setPixel(x, y, 0xFF00FF);
					map[x][y] = 1;
				} else {
					drawBitmap.setPixel(x, y, backColor);
					map[x][y] = 0;
				}				
			}
		}
				
		this.attachBitmap(drawBitmap, 1);
		
		this.calculatePoints();
	}
	
	public function calculatePoints():Void {
		
		var halfPointSize:Number = pointSize / 2;
		var points:Array = new Array();
		var len:Number = pointSize*pointSize;
		var i:Number = 0;
		
		for(var y=halfPointSize; y<h-halfPointSize; y++) {
			for(var x=halfPointSize; x<w-halfPointSize; x++) {
				if(map[x-halfPointSize][y-halfPointSize] == 1) {
					i = 0;
					while(i<len) {
						if(map[(x-halfPointSize)+(i%pointSize)][(y-halfPointSize)+ Math.floor(i/pointSize)] == 0) {
							break;
						}
						i++;
					}
					if(i == len) {
						//Ektrafi dolu bir nokta bulundu
						var point:Object = new Object();
						point.x = x;
						point.y = y;
						points.push(point);
					}
				}
			}
		}
		
		this.multiPoints = new Array();
		
		for(var i:Number = 0; i<points.length; i++) {
			if(!isIncludePoint(multiPoints, points[i])) {
				multiPoints.push(points[i]);
			}
		}
		
		
	}
	
	//Verilen noktayi icerip icermedigine bakar
	private function isIncludePoint(points:Array, point:Object):Boolean {
		for(var i:Number = 0; i<points.length; i++) {
			if(Math.abs(point.x - points[i].x) < minPointDistance && Math.abs(point.y - points[i].y) < minPointDistance) {
				return true;
			}
		}
		return false;
	}
	
	
	//istenilen renke yakin bir renk olup olmadigini donderir
	private function getNearColor(color:Number):Boolean {
		var fark:Number = Math.abs(color-targetColor);
		if(fark < F) {
			return true;
		} else {
			return false;
		}
		
	}
	
	public function getMultiPoints():Array {
		var back:Number = this.backColor;
		var points:Array = multiPoints;
		var len:Number = this.multiPoints.length;
		return this.multiPoints;
	}
	
}